/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-07 19:00:49 UTC)
 * on 2013-08-14 at 00:28:20 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.shopping.model;

/**
 * Model definition for Products.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Search API For Shopping. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Products extends com.google.api.client.json.GenericJson {

  /**
   * List of categories.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<ShoppingModelCategoryJsonV1> categories;

  static {
    // hack to force ProGuard to consider ShoppingModelCategoryJsonV1 used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(ShoppingModelCategoryJsonV1.class);
  }

  /**
   * Recommendations for category.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<ShoppingModelRecommendationsJsonV1> categoryRecommendations;

  static {
    // hack to force ProGuard to consider ShoppingModelRecommendationsJsonV1 used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(ShoppingModelRecommendationsJsonV1.class);
  }

  /**
   * Current item count.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer currentItemCount;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ShoppingModelDebugJsonV1 debug;

  /**
   * Etag of feed.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String etag;

  /**
   * List of extras.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ShoppingModelExtrasJsonV1 extras;

  /**
   * List of facets.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Facets> facets;

  static {
    // hack to force ProGuard to consider Facets used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Facets.class);
  }

  /**
   * Id of feed.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * List of returned products.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Product> items;

  static {
    // hack to force ProGuard to consider Product used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Product.class);
  }

  /**
   * Number of items per page of results.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer itemsPerPage;

  /**
   * The fixed string "shopping#products". The kind of feed returned.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Next link of feed.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextLink;

  /**
   * Previous link of feed.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String previousLink;

  /**
   * List of promotions.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Promotions> promotions;

  static {
    // hack to force ProGuard to consider Promotions used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Promotions.class);
  }

  /**
   * Redirects.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> redirects;

  /**
   * Related queries.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> relatedQueries;

  /**
   * Unique identifier for this request.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String requestId;

  /**
   * Self link of feed.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String selfLink;

  /**
   * Spelling.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Spelling spelling;

  /**
   * 1-based index of the first item in the search results.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer startIndex;

  /**
   * List of returned stores.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Stores> stores;

  static {
    // hack to force ProGuard to consider Stores used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Stores.class);
  }

  /**
   * Total number of search results.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer totalItems;

  /**
   * List of categories.
   * @return value or {@code null} for none
   */
  public java.util.List<ShoppingModelCategoryJsonV1> getCategories() {
    return categories;
  }

  /**
   * List of categories.
   * @param categories categories or {@code null} for none
   */
  public Products setCategories(java.util.List<ShoppingModelCategoryJsonV1> categories) {
    this.categories = categories;
    return this;
  }

  /**
   * Recommendations for category.
   * @return value or {@code null} for none
   */
  public java.util.List<ShoppingModelRecommendationsJsonV1> getCategoryRecommendations() {
    return categoryRecommendations;
  }

  /**
   * Recommendations for category.
   * @param categoryRecommendations categoryRecommendations or {@code null} for none
   */
  public Products setCategoryRecommendations(java.util.List<ShoppingModelRecommendationsJsonV1> categoryRecommendations) {
    this.categoryRecommendations = categoryRecommendations;
    return this;
  }

  /**
   * Current item count.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getCurrentItemCount() {
    return currentItemCount;
  }

  /**
   * Current item count.
   * @param currentItemCount currentItemCount or {@code null} for none
   */
  public Products setCurrentItemCount(java.lang.Integer currentItemCount) {
    this.currentItemCount = currentItemCount;
    return this;
  }

  /**
   * Google internal.
   * @return value or {@code null} for none
   */
  public ShoppingModelDebugJsonV1 getDebug() {
    return debug;
  }

  /**
   * Google internal.
   * @param debug debug or {@code null} for none
   */
  public Products setDebug(ShoppingModelDebugJsonV1 debug) {
    this.debug = debug;
    return this;
  }

  /**
   * Etag of feed.
   * @return value or {@code null} for none
   */
  public java.lang.String getEtag() {
    return etag;
  }

  /**
   * Etag of feed.
   * @param etag etag or {@code null} for none
   */
  public Products setEtag(java.lang.String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * List of extras.
   * @return value or {@code null} for none
   */
  public ShoppingModelExtrasJsonV1 getExtras() {
    return extras;
  }

  /**
   * List of extras.
   * @param extras extras or {@code null} for none
   */
  public Products setExtras(ShoppingModelExtrasJsonV1 extras) {
    this.extras = extras;
    return this;
  }

  /**
   * List of facets.
   * @return value or {@code null} for none
   */
  public java.util.List<Facets> getFacets() {
    return facets;
  }

  /**
   * List of facets.
   * @param facets facets or {@code null} for none
   */
  public Products setFacets(java.util.List<Facets> facets) {
    this.facets = facets;
    return this;
  }

  /**
   * Id of feed.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * Id of feed.
   * @param id id or {@code null} for none
   */
  public Products setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * List of returned products.
   * @return value or {@code null} for none
   */
  public java.util.List<Product> getItems() {
    return items;
  }

  /**
   * List of returned products.
   * @param items items or {@code null} for none
   */
  public Products setItems(java.util.List<Product> items) {
    this.items = items;
    return this;
  }

  /**
   * Number of items per page of results.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getItemsPerPage() {
    return itemsPerPage;
  }

  /**
   * Number of items per page of results.
   * @param itemsPerPage itemsPerPage or {@code null} for none
   */
  public Products setItemsPerPage(java.lang.Integer itemsPerPage) {
    this.itemsPerPage = itemsPerPage;
    return this;
  }

  /**
   * The fixed string "shopping#products". The kind of feed returned.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The fixed string "shopping#products". The kind of feed returned.
   * @param kind kind or {@code null} for none
   */
  public Products setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Next link of feed.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextLink() {
    return nextLink;
  }

  /**
   * Next link of feed.
   * @param nextLink nextLink or {@code null} for none
   */
  public Products setNextLink(java.lang.String nextLink) {
    this.nextLink = nextLink;
    return this;
  }

  /**
   * Previous link of feed.
   * @return value or {@code null} for none
   */
  public java.lang.String getPreviousLink() {
    return previousLink;
  }

  /**
   * Previous link of feed.
   * @param previousLink previousLink or {@code null} for none
   */
  public Products setPreviousLink(java.lang.String previousLink) {
    this.previousLink = previousLink;
    return this;
  }

  /**
   * List of promotions.
   * @return value or {@code null} for none
   */
  public java.util.List<Promotions> getPromotions() {
    return promotions;
  }

  /**
   * List of promotions.
   * @param promotions promotions or {@code null} for none
   */
  public Products setPromotions(java.util.List<Promotions> promotions) {
    this.promotions = promotions;
    return this;
  }

  /**
   * Redirects.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getRedirects() {
    return redirects;
  }

  /**
   * Redirects.
   * @param redirects redirects or {@code null} for none
   */
  public Products setRedirects(java.util.List<java.lang.String> redirects) {
    this.redirects = redirects;
    return this;
  }

  /**
   * Related queries.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getRelatedQueries() {
    return relatedQueries;
  }

  /**
   * Related queries.
   * @param relatedQueries relatedQueries or {@code null} for none
   */
  public Products setRelatedQueries(java.util.List<java.lang.String> relatedQueries) {
    this.relatedQueries = relatedQueries;
    return this;
  }

  /**
   * Unique identifier for this request.
   * @return value or {@code null} for none
   */
  public java.lang.String getRequestId() {
    return requestId;
  }

  /**
   * Unique identifier for this request.
   * @param requestId requestId or {@code null} for none
   */
  public Products setRequestId(java.lang.String requestId) {
    this.requestId = requestId;
    return this;
  }

  /**
   * Self link of feed.
   * @return value or {@code null} for none
   */
  public java.lang.String getSelfLink() {
    return selfLink;
  }

  /**
   * Self link of feed.
   * @param selfLink selfLink or {@code null} for none
   */
  public Products setSelfLink(java.lang.String selfLink) {
    this.selfLink = selfLink;
    return this;
  }

  /**
   * Spelling.
   * @return value or {@code null} for none
   */
  public Spelling getSpelling() {
    return spelling;
  }

  /**
   * Spelling.
   * @param spelling spelling or {@code null} for none
   */
  public Products setSpelling(Spelling spelling) {
    this.spelling = spelling;
    return this;
  }

  /**
   * 1-based index of the first item in the search results.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getStartIndex() {
    return startIndex;
  }

  /**
   * 1-based index of the first item in the search results.
   * @param startIndex startIndex or {@code null} for none
   */
  public Products setStartIndex(java.lang.Integer startIndex) {
    this.startIndex = startIndex;
    return this;
  }

  /**
   * List of returned stores.
   * @return value or {@code null} for none
   */
  public java.util.List<Stores> getStores() {
    return stores;
  }

  /**
   * List of returned stores.
   * @param stores stores or {@code null} for none
   */
  public Products setStores(java.util.List<Stores> stores) {
    this.stores = stores;
    return this;
  }

  /**
   * Total number of search results.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getTotalItems() {
    return totalItems;
  }

  /**
   * Total number of search results.
   * @param totalItems totalItems or {@code null} for none
   */
  public Products setTotalItems(java.lang.Integer totalItems) {
    this.totalItems = totalItems;
    return this;
  }

  @Override
  public Products set(String fieldName, Object value) {
    return (Products) super.set(fieldName, value);
  }

  @Override
  public Products clone() {
    return (Products) super.clone();
  }

  /**
   * Model definition for ProductsFacets.
   */
  public static final class Facets extends com.google.api.client.json.GenericJson {

    /**
     * List of Buckets within facet.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<Buckets> buckets;

    static {
      // hack to force ProGuard to consider Buckets used, since otherwise it would be stripped out
      // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
      com.google.api.client.util.Data.nullOf(Buckets.class);
    }

    /**
     * Number of products matching the query that have a value for the facet's property or attribute.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer count;

    /**
     * Display name of facet.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String displayName;

    /**
     * Name of the facet's attribute (omitted for property facets).
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String name;

    /**
     * Property of facet (omitted for attribute facets).
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String property;

    /**
     * Type of facet's attribute (omitted for property facets, one of: text, bool, int, float).
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String type;

    /**
     * Unit of the facet's property or attribute (omitted if the facet's property or attribute has no
     * unit).
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String unit;

    /**
     * List of Buckets within facet.
     * @return value or {@code null} for none
     */
    public java.util.List<Buckets> getBuckets() {
      return buckets;
    }

    /**
     * List of Buckets within facet.
     * @param buckets buckets or {@code null} for none
     */
    public Facets setBuckets(java.util.List<Buckets> buckets) {
      this.buckets = buckets;
      return this;
    }

    /**
     * Number of products matching the query that have a value for the facet's property or attribute.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getCount() {
      return count;
    }

    /**
     * Number of products matching the query that have a value for the facet's property or attribute.
     * @param count count or {@code null} for none
     */
    public Facets setCount(java.lang.Integer count) {
      this.count = count;
      return this;
    }

    /**
     * Display name of facet.
     * @return value or {@code null} for none
     */
    public java.lang.String getDisplayName() {
      return displayName;
    }

    /**
     * Display name of facet.
     * @param displayName displayName or {@code null} for none
     */
    public Facets setDisplayName(java.lang.String displayName) {
      this.displayName = displayName;
      return this;
    }

    /**
     * Name of the facet's attribute (omitted for property facets).
     * @return value or {@code null} for none
     */
    public java.lang.String getName() {
      return name;
    }

    /**
     * Name of the facet's attribute (omitted for property facets).
     * @param name name or {@code null} for none
     */
    public Facets setName(java.lang.String name) {
      this.name = name;
      return this;
    }

    /**
     * Property of facet (omitted for attribute facets).
     * @return value or {@code null} for none
     */
    public java.lang.String getProperty() {
      return property;
    }

    /**
     * Property of facet (omitted for attribute facets).
     * @param property property or {@code null} for none
     */
    public Facets setProperty(java.lang.String property) {
      this.property = property;
      return this;
    }

    /**
     * Type of facet's attribute (omitted for property facets, one of: text, bool, int, float).
     * @return value or {@code null} for none
     */
    public java.lang.String getType() {
      return type;
    }

    /**
     * Type of facet's attribute (omitted for property facets, one of: text, bool, int, float).
     * @param type type or {@code null} for none
     */
    public Facets setType(java.lang.String type) {
      this.type = type;
      return this;
    }

    /**
     * Unit of the facet's property or attribute (omitted if the facet's property or attribute has no
     * unit).
     * @return value or {@code null} for none
     */
    public java.lang.String getUnit() {
      return unit;
    }

    /**
     * Unit of the facet's property or attribute (omitted if the facet's property or attribute has no
     * unit).
     * @param unit unit or {@code null} for none
     */
    public Facets setUnit(java.lang.String unit) {
      this.unit = unit;
      return this;
    }

    @Override
    public Facets set(String fieldName, Object value) {
      return (Facets) super.set(fieldName, value);
    }

    @Override
    public Facets clone() {
      return (Facets) super.clone();
    }

    /**
     * Model definition for ProductsFacetsBuckets.
     */
    public static final class Buckets extends com.google.api.client.json.GenericJson {

      /**
       * Number of products matching the query that have a value for the facet's property or attribute
       * that matches the bucket.
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.Integer count;

      /**
       * Upper bound of the bucket (omitted for value buckets or if the range has no upper bound).
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.Object max;

      /**
       * Whether the upper bound of the bucket is exclusive (omitted for value buckets or if the range
       * has no upper bound).
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.Boolean maxExclusive;

      /**
       * Lower bound of the bucket (omitted for value buckets or if the range has no lower bound).
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.Object min;

      /**
       * Whether the lower bound of the bucket is exclusive (omitted for value buckets or if the range
       * has no lower bound).
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.Boolean minExclusive;

      /**
       * Value of the bucket (omitted for range buckets).
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.Object value;

      /**
       * Number of products matching the query that have a value for the facet's property or attribute
       * that matches the bucket.
       * @return value or {@code null} for none
       */
      public java.lang.Integer getCount() {
        return count;
      }

      /**
       * Number of products matching the query that have a value for the facet's property or attribute
       * that matches the bucket.
       * @param count count or {@code null} for none
       */
      public Buckets setCount(java.lang.Integer count) {
        this.count = count;
        return this;
      }

      /**
       * Upper bound of the bucket (omitted for value buckets or if the range has no upper bound).
       * @return value or {@code null} for none
       */
      public java.lang.Object getMax() {
        return max;
      }

      /**
       * Upper bound of the bucket (omitted for value buckets or if the range has no upper bound).
       * @param max max or {@code null} for none
       */
      public Buckets setMax(java.lang.Object max) {
        this.max = max;
        return this;
      }

      /**
       * Whether the upper bound of the bucket is exclusive (omitted for value buckets or if the range
       * has no upper bound).
       * @return value or {@code null} for none
       */
      public java.lang.Boolean getMaxExclusive() {
        return maxExclusive;
      }

      /**
       * Whether the upper bound of the bucket is exclusive (omitted for value buckets or if the range
       * has no upper bound).
       * @param maxExclusive maxExclusive or {@code null} for none
       */
      public Buckets setMaxExclusive(java.lang.Boolean maxExclusive) {
        this.maxExclusive = maxExclusive;
        return this;
      }

      /**
       * Lower bound of the bucket (omitted for value buckets or if the range has no lower bound).
       * @return value or {@code null} for none
       */
      public java.lang.Object getMin() {
        return min;
      }

      /**
       * Lower bound of the bucket (omitted for value buckets or if the range has no lower bound).
       * @param min min or {@code null} for none
       */
      public Buckets setMin(java.lang.Object min) {
        this.min = min;
        return this;
      }

      /**
       * Whether the lower bound of the bucket is exclusive (omitted for value buckets or if the range
       * has no lower bound).
       * @return value or {@code null} for none
       */
      public java.lang.Boolean getMinExclusive() {
        return minExclusive;
      }

      /**
       * Whether the lower bound of the bucket is exclusive (omitted for value buckets or if the range
       * has no lower bound).
       * @param minExclusive minExclusive or {@code null} for none
       */
      public Buckets setMinExclusive(java.lang.Boolean minExclusive) {
        this.minExclusive = minExclusive;
        return this;
      }

      /**
       * Value of the bucket (omitted for range buckets).
       * @return value or {@code null} for none
       */
      public java.lang.Object getValue() {
        return value;
      }

      /**
       * Value of the bucket (omitted for range buckets).
       * @param value value or {@code null} for none
       */
      public Buckets setValue(java.lang.Object value) {
        this.value = value;
        return this;
      }

      @Override
      public Buckets set(String fieldName, Object value) {
        return (Buckets) super.set(fieldName, value);
      }

      @Override
      public Buckets clone() {
        return (Buckets) super.clone();
      }

    }
  }

  /**
   * Model definition for ProductsPromotions.
   */
  public static final class Promotions extends com.google.api.client.json.GenericJson {

    /**
     * List of custom fields of promotion.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<CustomFields> customFields;

    static {
      // hack to force ProGuard to consider CustomFields used, since otherwise it would be stripped out
      // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
      com.google.api.client.util.Data.nullOf(CustomFields.class);
    }

    /**
     * Custom HTML of promotion (omitted if type is not custom).
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String customHtml;

    /**
     * Description of promotion (omitted if type is not standard).
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String description;

    /**
     * Link to promotion (omitted if type is not standard).
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String destLink;

    /**
     * Link to promotion image (omitted if type is not standard).
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String imageLink;

    /**
     * Name of promotion (omitted if type is not standard).
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String name;

    /**
     * Product of promotion (omitted if type is not product).
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private ShoppingModelProductJsonV1 product;

    /**
     * Type of promotion (one of: standard, product, custom).
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String type;

    /**
     * List of custom fields of promotion.
     * @return value or {@code null} for none
     */
    public java.util.List<CustomFields> getCustomFields() {
      return customFields;
    }

    /**
     * List of custom fields of promotion.
     * @param customFields customFields or {@code null} for none
     */
    public Promotions setCustomFields(java.util.List<CustomFields> customFields) {
      this.customFields = customFields;
      return this;
    }

    /**
     * Custom HTML of promotion (omitted if type is not custom).
     * @return value or {@code null} for none
     */
    public java.lang.String getCustomHtml() {
      return customHtml;
    }

    /**
     * Custom HTML of promotion (omitted if type is not custom).
     * @param customHtml customHtml or {@code null} for none
     */
    public Promotions setCustomHtml(java.lang.String customHtml) {
      this.customHtml = customHtml;
      return this;
    }

    /**
     * Description of promotion (omitted if type is not standard).
     * @return value or {@code null} for none
     */
    public java.lang.String getDescription() {
      return description;
    }

    /**
     * Description of promotion (omitted if type is not standard).
     * @param description description or {@code null} for none
     */
    public Promotions setDescription(java.lang.String description) {
      this.description = description;
      return this;
    }

    /**
     * Link to promotion (omitted if type is not standard).
     * @return value or {@code null} for none
     */
    public java.lang.String getDestLink() {
      return destLink;
    }

    /**
     * Link to promotion (omitted if type is not standard).
     * @param destLink destLink or {@code null} for none
     */
    public Promotions setDestLink(java.lang.String destLink) {
      this.destLink = destLink;
      return this;
    }

    /**
     * Link to promotion image (omitted if type is not standard).
     * @return value or {@code null} for none
     */
    public java.lang.String getImageLink() {
      return imageLink;
    }

    /**
     * Link to promotion image (omitted if type is not standard).
     * @param imageLink imageLink or {@code null} for none
     */
    public Promotions setImageLink(java.lang.String imageLink) {
      this.imageLink = imageLink;
      return this;
    }

    /**
     * Name of promotion (omitted if type is not standard).
     * @return value or {@code null} for none
     */
    public java.lang.String getName() {
      return name;
    }

    /**
     * Name of promotion (omitted if type is not standard).
     * @param name name or {@code null} for none
     */
    public Promotions setName(java.lang.String name) {
      this.name = name;
      return this;
    }

    /**
     * Product of promotion (omitted if type is not product).
     * @return value or {@code null} for none
     */
    public ShoppingModelProductJsonV1 getProduct() {
      return product;
    }

    /**
     * Product of promotion (omitted if type is not product).
     * @param product product or {@code null} for none
     */
    public Promotions setProduct(ShoppingModelProductJsonV1 product) {
      this.product = product;
      return this;
    }

    /**
     * Type of promotion (one of: standard, product, custom).
     * @return value or {@code null} for none
     */
    public java.lang.String getType() {
      return type;
    }

    /**
     * Type of promotion (one of: standard, product, custom).
     * @param type type or {@code null} for none
     */
    public Promotions setType(java.lang.String type) {
      this.type = type;
      return this;
    }

    @Override
    public Promotions set(String fieldName, Object value) {
      return (Promotions) super.set(fieldName, value);
    }

    @Override
    public Promotions clone() {
      return (Promotions) super.clone();
    }

    /**
     * Model definition for ProductsPromotionsCustomFields.
     */
    public static final class CustomFields extends com.google.api.client.json.GenericJson {

      /**
       * Name of field.
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.String name;

      /**
       * Value of field.
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.String value;

      /**
       * Name of field.
       * @return value or {@code null} for none
       */
      public java.lang.String getName() {
        return name;
      }

      /**
       * Name of field.
       * @param name name or {@code null} for none
       */
      public CustomFields setName(java.lang.String name) {
        this.name = name;
        return this;
      }

      /**
       * Value of field.
       * @return value or {@code null} for none
       */
      public java.lang.String getValue() {
        return value;
      }

      /**
       * Value of field.
       * @param value value or {@code null} for none
       */
      public CustomFields setValue(java.lang.String value) {
        this.value = value;
        return this;
      }

      @Override
      public CustomFields set(String fieldName, Object value) {
        return (CustomFields) super.set(fieldName, value);
      }

      @Override
      public CustomFields clone() {
        return (CustomFields) super.clone();
      }

    }
  }

  /**
   * Spelling.
   */
  public static final class Spelling extends com.google.api.client.json.GenericJson {

    /**
     * Suggestion for spelling.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String suggestion;

    /**
     * Suggestion for spelling.
     * @return value or {@code null} for none
     */
    public java.lang.String getSuggestion() {
      return suggestion;
    }

    /**
     * Suggestion for spelling.
     * @param suggestion suggestion or {@code null} for none
     */
    public Spelling setSuggestion(java.lang.String suggestion) {
      this.suggestion = suggestion;
      return this;
    }

    @Override
    public Spelling set(String fieldName, Object value) {
      return (Spelling) super.set(fieldName, value);
    }

    @Override
    public Spelling clone() {
      return (Spelling) super.clone();
    }

  }

  /**
   * Model definition for ProductsStores.
   */
  public static final class Stores extends com.google.api.client.json.GenericJson {

    /**
     * Address of store.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String address;

    /**
     * Location of store.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String location;

    /**
     * Name of merchant.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String name;

    /**
     * Merchant-supplied store code.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String storeCode;

    /**
     * Id of store.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String storeId;

    /**
     * Name of store.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String storeName;

    /**
     * Telephone number of store.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String telephone;

    /**
     * Address of store.
     * @return value or {@code null} for none
     */
    public java.lang.String getAddress() {
      return address;
    }

    /**
     * Address of store.
     * @param address address or {@code null} for none
     */
    public Stores setAddress(java.lang.String address) {
      this.address = address;
      return this;
    }

    /**
     * Location of store.
     * @return value or {@code null} for none
     */
    public java.lang.String getLocation() {
      return location;
    }

    /**
     * Location of store.
     * @param location location or {@code null} for none
     */
    public Stores setLocation(java.lang.String location) {
      this.location = location;
      return this;
    }

    /**
     * Name of merchant.
     * @return value or {@code null} for none
     */
    public java.lang.String getName() {
      return name;
    }

    /**
     * Name of merchant.
     * @param name name or {@code null} for none
     */
    public Stores setName(java.lang.String name) {
      this.name = name;
      return this;
    }

    /**
     * Merchant-supplied store code.
     * @return value or {@code null} for none
     */
    public java.lang.String getStoreCode() {
      return storeCode;
    }

    /**
     * Merchant-supplied store code.
     * @param storeCode storeCode or {@code null} for none
     */
    public Stores setStoreCode(java.lang.String storeCode) {
      this.storeCode = storeCode;
      return this;
    }

    /**
     * Id of store.
     * @return value or {@code null} for none
     */
    public java.lang.String getStoreId() {
      return storeId;
    }

    /**
     * Id of store.
     * @param storeId storeId or {@code null} for none
     */
    public Stores setStoreId(java.lang.String storeId) {
      this.storeId = storeId;
      return this;
    }

    /**
     * Name of store.
     * @return value or {@code null} for none
     */
    public java.lang.String getStoreName() {
      return storeName;
    }

    /**
     * Name of store.
     * @param storeName storeName or {@code null} for none
     */
    public Stores setStoreName(java.lang.String storeName) {
      this.storeName = storeName;
      return this;
    }

    /**
     * Telephone number of store.
     * @return value or {@code null} for none
     */
    public java.lang.String getTelephone() {
      return telephone;
    }

    /**
     * Telephone number of store.
     * @param telephone telephone or {@code null} for none
     */
    public Stores setTelephone(java.lang.String telephone) {
      this.telephone = telephone;
      return this;
    }

    @Override
    public Stores set(String fieldName, Object value) {
      return (Stores) super.set(fieldName, value);
    }

    @Override
    public Stores clone() {
      return (Stores) super.clone();
    }

  }

}
